Description

Supportanfrage

Um Byte Arrays über pins zu verschicken habe ich folgende Implementierungsbeispiele gefunden.

https://support.digitalwerk.net/adtf/v3/adtf_html/page_streaming_architecture.html#sec_sample

Was ist der Unterschied zwischen folgenden Beispielen

"Set a memory buffer to the sample"

"Write a memory buffer to the samples buffer"

Aus Quellcode und Beschreibung ist es mir direkt nicht ersichtlich.

Lösung

Beide Möglichkeiten machen am Ende genau dasselbe, es gibt quasi keinen Unterschied. Der einzige Unterschied besteht darin,

dass

mit "Set a memory buffer to the sample" wird die Methode ISample::Set gerufen (daher das "Set a memory buffer... ")

mit Write a memory buffer to the samples Buffer wird erst der Buffer "geholt" mit ISample::WriteLock und dann mit

ISampleBuffer::Write beschrieben (daher der Name "Write a memory buffer...")

Das ISample::Set macht in seiner Umsetzung genau dasselbe intern, d.h. es holt sich den Sample Buffer, Macht einen WriteLock

darauf, Kopiert den Memory Blcok mit Write und released den Lock wieder. Solange ein WriteLock auf dem SampleBuffer ist, kann

kein ReadLock gemacht werden. Der SampleBuffer ist somit gegen ein gleichzeitiges beschreiben und lesen abgesichert.

Grund für die Absicherung ist, dass ISampleBuffer ein Interface ist, wie ISample auch und es verschiedene Implementierungen

geben kann (normalerweise verwenden alle immer die Default-Implemetierung, aber man weiß ja nie).

History

#1 - 2021-06-11 20:48 - hidden

- Status changed from New to In Progress

- Private changed from No to Yes

- Topic set to ADTF::StreamingSDK

#2 - 2021-06-15 12:58 - hidden

- Status changed from In Progress to Customer Feedback Required

Hallo Thomas,

Beide Möglichkeiten machen am Ende genau dasselbe, es gibt quasi keinen Unterschied. Der einzige Unterschied besteht darin, dass

(1) mit "Set a memory buffer to the sample" wird die Methode ISample::Set gerufen (daher das "Set a memory buffer... ")

(2) mit Write a memory buffer to the samples Buffer wird erst der Buffer "geholt" mit ISample::WriteLock und dann mit ISampleBuffer::Write

beschrieben (daher der Name "Write a memory buffer...")

Gern ändere ich die Formulierung, wenn das nicht eindeutig und schwer verständlich ist.
https://support.digitalwerk.net/adtf/v3/adtf_html/page_streaming_architecture.html#sec_sample


Viele Grüße Pierre

#3 - 2021-06-16 12:50 - hidden

Hallo Pierre,

bei dem Beispiel 1 wird kein "WriteLock" auf dem sample durchgeführt wie im Beispiel 2.

Ist es im Beispiel 1 dann nicht notwendig für eine sichere Ausführung ?

Was sind die Gründe für das Ausführen eines WriteLock ?

Gruß Thomas

#4 - 2021-06-16 12:57 - hidden

Hallo Thomas,

Das ISample::Set macht in seiner Umsetzung genau dasselbe intern, d.h. es holt sich den Sample Buffer, Macht einen WriteLock darauf, Kopiert den

Memory Blcok mit Write und released den Lock wieder. Solange ein WriteLock auf dem SampleBuffer ist, kann kein ReadLock gemacht werden. Der

SampleBuffer ist somit gegen ein gleichzeitiges beschreiben und lesen abgesichert.

Grund für die Absicherung ist, dass ISampleBuffer ein Interface ist, wie ISample auch und es verschiedene Implementierungen geben kann

(normalerweise verwenden alle immer die Default-Implemetierung, aber man weiß ja nie).

Grüße Pierre

#5 - 2021-06-16 13:03 - hidden

Hallo Pierre,

danke. Diese Erklärung hat mir gefehlt.

es macht mich immer ein bisschen vorsichtig / stutzig, wenn in einem Beispiel Elemente enthalten sind und in einem anderen nicht.

Meine Fragen sind beantwortet, von meiner Seite kann das Ticket geschlossen werden.

Gruß Thomas

#6 - 2021-06-16 13:06 - hidden

- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue

#7 - 2021-06-16 13:16 - hidden

- Project changed from 5 to Public Support

- Subject changed from Memory Buffer über Samples verschicken. to How to send byte arrays / memory buffers within samples

- Description updated

- Private changed from Yes to No

#8 - 2022-01-17 08:17 - hidden

- Status changed from To Be Closed to Closed
